require 'getoptlong'

class Conf
  attr_reader :filename, :smoke, :font, :level, :type

  def initialize
	@filename = "cathedral.txt"
	@smoke = true
	@font = "font.ttf"
	@level = 0
	@type = "text"

	opts = GetoptLong.new (
						   [ "--nosmoke", "-s", GetoptLong::NO_ARGUMENT ],
						   [ "--level", "-l", GetoptLong::REQUIRED_ARGUMENT ],
						   [ "--font", "-f", GetoptLong::REQUIRED_ARGUMENT ],
						   [ "--type", "-t", GetoptLong::REQUIRED_ARGUMENT ],
						   [ "--help", "-h", GetoptLong::NO_ARGUMENT ]
						   )

	if opts.error? then
	  print opts.error_message + "\n"
	  help
	end

	opts.each do |opt, arg|
	  if opt == "--nosmoke" then
		@smoke = false
	  elsif opt == "--level" then
		@level = arg.to_i
		if @level < 0 then
		  @level = 0
		end
	  elsif opt == "--type" then
		@type = arg
		if @type == "dat" then
		  @filename = "cathedral.dat"
		elsif @type != "text" then
		  help
		end
	  elsif opt == "--font" then
		@font = arg
	  elsif opt == "--help" then
		help
	  else
		help
	  end
	end


	if ARGV[0] then
	  @filename = ARGV[0]
	end
  end

  def help
	print "" +
	  "Usage: ruby main.rb [-options] [source text file]\n" +
	  "\t--nosmoke, -s  \tdont smoke efftct.\n" +
	  "\t--level, -l num\tset start level.\n" +
	  "\t--font, -f font\tset font.\n" +
	  "\t--type, -t type\tset file type, text or dat.\n" +
	  "\t--help, -h     \tshow this help.\n"
	exit
  end

end

