require 'sdl'

class FPSTimer
  attr_reader :shouldSkip, :turn

  def initialize(fps, minFps)
	@first = @estimated = SDL.getTicks
	@ticksPerTurn = 1000 / fps
	@minTicksPerTurn = 1000 / minFps
	@shouldSkip = false
	@turn = 0
	@finalDrawTime = 0
	@skipTurn = 0
  end

  def wait
	@turn += 1
	@estimated += @ticksPerTurn
	ticks = SDL.getTicks
	if @estimated > ticks
	  @finalDrawTime = ticks
	  @shouldSkip = false
	  SDL.delay(@estimated - ticks)
	else
	  if @finalDrawTime + @minTicksPerTurn > ticks then
		@finalDrawTime = ticks
		@shouldSkip = false
	  else
		@shouldSkip = true
		@skipTurn += 1
	  end
	end
  end

  def getTrueFps
	return @turn * 1000.0 / (SDL.getTicks - @first)
  end

  def getFrameFps
	return (@turn - @skipTurn) * 1000.0 / (SDL.getTicks - @first)
  end

end
