require 'kakasi'
require 'chasen'

class MarkovGenerater
  def initialize(filename)
	src = File.new(filename).gets("\0")
	dst = Kakasi.kakasi("-oeuc -w", src)

	@npref = 2
	@prefix = Array.new
	@statetab = Hash.new

	@keys = Array.new
	@endSeps = [ '', '', '', '', '', '', '', '' ]

	for i in 0...@npref
	  add("\0")
	end

	dst.split(/\s+/).each { |s| add(s) }

	add("\0")

	@prefix = @keys[rand(@keys.size)]

	Chasen.getopt("-F", "%h ")
  end

  def add(str)
	if @prefix.size == @npref then
	  pref = @prefix.collect{|x| x}
	  if !@statetab.has_key?(pref) then
		@statetab[pref] = Array.new
	  end
	  @statetab[pref].push(str)

	  @prefix.shift
	  @prefix.push(str)

	  if @endSeps.index(str) then
		@keys.push(@prefix.collect{|x| x})
	  end
	else
	  @prefix.push(str)
	end
  end

  def getNext
	suf = @statetab[@prefix]

	while suf == nil
	  @prefix = @keys[rand(@keys.size)]
	  suf = @statetab[@prefix]
	end

	return suf[rand(suf.size)]
  end

  def generate
	ret = String.new("")
	w = String.new("")
	lpEnd = false
	while 1
	  begin
		w = getNext
	  end while ret.empty? && @endSeps.index(w)
	  tmp = ret + w

	  tp = 0
	  if ret.size > 10 then
		types = Chasen.sparse(tmp).split(/ /)
		types.pop
		tp = types.pop.to_i

		if tp < 49 then
		  if types.pop.to_i >= 38  then
			return ret
		  end
		end
	  end

	  if ret.size > 30 && !@endSeps.index(w) then
		return ret
	  end

	  ret = tmp
	  @prefix.shift
	  @prefix.push(w)

	  if (@endSeps.index(w) && ret.size > 10) then
		w = getNext
		if @endSeps.index(w) then
		  @prefix.shift
		  @prefix.push(w)
		  return ret + w
		else
		  return ret
		end
	  end
	end
  end

end

